#!/usr/bin/perl

package SurveyTown;
use strict;

use HTTP::Request;
use LWP::UserAgent;
use PHP::HTTPBuildQuery qw(http_build_query);
use base 'HTTP::Message';
use JSON;

my $self;
my $data;
my $args;

		
	sub Integration_Get_Cookie {
		$self = shift;
		my ( $clientId, $username, $time ) = @_; 
		$args = {};
		$args->{'method'} = 'Integration_Get_Cookie';
		$args->{'clientId'} = $clientId;
		$args->{'username'} = $username;
		if ( ! $time ) { $time = ''}
		$args->{'time'} = $time;

		
		$data = makeCall( $self, $args );
		
		return $data;
	}		
	sub Integration_Login_Get_Cookie {
		$self = shift;
		my ( $username, $password, $time ) = @_; 
		$args = {};
		$args->{'method'} = 'Integration_Login_Get_Cookie';
		$args->{'username'} = $username;
		$args->{'password'} = $password;
		if ( ! $time ) { $time = ''}
		$args->{'time'} = $time;

		
		$data = makeCall( $self, $args );
		
		return $data;
	}		
	sub Response_Create {
		$self = shift;
		my ( $surveyId, $updateParameters, $optionalParameters ) = @_; 
		$args = {};
		$args->{'method'} = 'Response_Create';
		$args->{'surveyId'} = $surveyId;
		$args->{'updateParameters'} = $updateParameters;
		if ( ! $optionalParameters ) { $optionalParameters = {}}
		$args->{'optionalParameters'} = $optionalParameters;

		
		$data = makeCall( $self, $args );
		
		return $data;
	}		
	sub Response_Update {
		$self = shift;
		my ( $surveyId, $responseId, $updateParameters, $optionalParameters ) = @_; 
		$args = {};
		$args->{'method'} = 'Response_Update';
		$args->{'surveyId'} = $surveyId;
		$args->{'responseId'} = $responseId;
		$args->{'updateParameters'} = $updateParameters;
		if ( ! $optionalParameters ) { $optionalParameters = {}}
		$args->{'optionalParameters'} = $optionalParameters;

		
		$data = makeCall( $self, $args );
		
		return $data;
	}		
	sub Response_Delete {
		$self = shift;
		my ( $surveyId, $responseId ) = @_; 
		$args = {};
		$args->{'method'} = 'Response_Delete';
		$args->{'surveyId'} = $surveyId;
		$args->{'responseId'} = $responseId;

		
		$data = makeCall( $self, $args );
		
		return $data;
	}		
	sub Survey_Start {
		$self = shift;
		my ( $surveyId ) = @_; 
		$args = {};
		$args->{'method'} = 'Survey_Start';
		$args->{'surveyId'} = $surveyId;

		
		$data = makeCall( $self, $args );
		
		return $data;
	}		
	sub Survey_Stop {
		$self = shift;
		my ( $surveyId ) = @_; 
		$args = {};
		$args->{'method'} = 'Survey_Stop';
		$args->{'surveyId'} = $surveyId;

		
		$data = makeCall( $self, $args );
		
		return $data;
	}		
	sub Survey_Copy {
		$self = shift;
		my ( $surveyId ) = @_; 
		$args = {};
		$args->{'method'} = 'Survey_Copy';
		$args->{'surveyId'} = $surveyId;

		
		$data = makeCall( $self, $args );
		
		return $data;
	}		
	sub Survey_Delete {
		$self = shift;
		my ( $surveyId ) = @_; 
		$args = {};
		$args->{'method'} = 'Survey_Delete';
		$args->{'surveyId'} = $surveyId;

		
		$data = makeCall( $self, $args );
		
		return $data;
	}		
	sub Survey_List {
		$self = shift;
		
		$args = {};
		$args->{'method'} = 'Survey_List';

		
		$data = makeCall( $self, $args );
		
		return $data;
	}		
	sub Survey_Find {
		$self = shift;
		my ( $optionalParameters ) = @_; 
		$args = {};
		$args->{'method'} = 'Survey_Find';
		if ( ! $optionalParameters ) { $optionalParameters = {}}
		$args->{'optionalParameters'} = $optionalParameters;

		
		$data = makeCall( $self, $args );
		
		return $data;
	}		
	sub Survey_Get_Info {
		$self = shift;
		my ( $surveyId ) = @_; 
		$args = {};
		$args->{'method'} = 'Survey_Get_Info';
		$args->{'surveyId'} = $surveyId;

		
		$data = makeCall( $self, $args );
		
		return $data;
	}		
	sub Survey_Get_Questions {
		$self = shift;
		my ( $surveyId ) = @_; 
		$args = {};
		$args->{'method'} = 'Survey_Get_Questions';
		$args->{'surveyId'} = $surveyId;

		
		$data = makeCall( $self, $args );
		
		return $data;
	}		
	sub Survey_Get_Response_Count {
		$self = shift;
		my ( $surveyId ) = @_; 
		$args = {};
		$args->{'method'} = 'Survey_Get_Response_Count';
		$args->{'surveyId'} = $surveyId;

		
		$data = makeCall( $self, $args );
		
		return $data;
	}		
	sub Survey_Get_Responses_By_Email {
		$self = shift;
		my ( $emailAddress, $optionalParameters ) = @_; 
		$args = {};
		$args->{'method'} = 'Survey_Get_Responses_By_Email';
		$args->{'emailAddress'} = $emailAddress;
		if ( ! $optionalParameters ) { $optionalParameters = {}}
		$args->{'optionalParameters'} = $optionalParameters;

		
		$data = makeCall( $self, $args );
		
		return $data;
	}		
	sub Survey_Get_Responses {
		$self = shift;
		my ( $surveyId, $optionalParameters ) = @_; 
		$args = {};
		$args->{'method'} = 'Survey_Get_Responses';
		$args->{'surveyId'} = $surveyId;
		if ( ! $optionalParameters ) { $optionalParameters = {}}
		$args->{'optionalParameters'} = $optionalParameters;

		
		$data = makeCall( $self, $args );
		
		return $data;
	}		
	sub Survey_Get_Responses_Zapier {
		$self = shift;
		
		$args = {};
		$args->{'method'} = 'Survey_Get_Responses_Zapier';

		
		$data = makeCall( $self, $args );
		
		return $data;
	}		
	sub Survey_Add_Tag {
		$self = shift;
		my ( $surveyId, $tagId ) = @_; 
		$args = {};
		$args->{'method'} = 'Survey_Add_Tag';
		$args->{'surveyId'} = $surveyId;
		$args->{'tagId'} = $tagId;

		
		$data = makeCall( $self, $args );
		
		return $data;
	}		
	sub Survey_Remove_Tag {
		$self = shift;
		my ( $surveyId, $tagId ) = @_; 
		$args = {};
		$args->{'method'} = 'Survey_Remove_Tag';
		$args->{'surveyId'} = $surveyId;
		$args->{'tagId'} = $tagId;

		
		$data = makeCall( $self, $args );
		
		return $data;
	}		
	sub Tag_Create {
		$self = shift;
		my ( $name ) = @_; 
		$args = {};
		$args->{'method'} = 'Tag_Create';
		$args->{'name'} = $name;

		
		$data = makeCall( $self, $args );
		
		return $data;
	}		
	sub Tag_Update {
		$self = shift;
		my ( $tagId, $updateParameters ) = @_; 
		$args = {};
		$args->{'method'} = 'Tag_Update';
		$args->{'tagId'} = $tagId;
		$args->{'updateParameters'} = $updateParameters;

		
		$data = makeCall( $self, $args );
		
		return $data;
	}		
	sub Tag_Delete {
		$self = shift;
		my ( $tagId ) = @_; 
		$args = {};
		$args->{'method'} = 'Tag_Delete';
		$args->{'tagId'} = $tagId;

		
		$data = makeCall( $self, $args );
		
		return $data;
	}		
	sub Tag_List {
		$self = shift;
		my ( $optionalParameters ) = @_; 
		$args = {};
		$args->{'method'} = 'Tag_List';
		if ( ! $optionalParameters ) { $optionalParameters = {}}
		$args->{'optionalParameters'} = $optionalParameters;

		
		$data = makeCall( $self, $args );
		
		return $data;
	}



sub new {
	my $proto = shift;
	my $key = shift;
	my $useHTTPS = shift;
    my $class = ref($proto) || $proto;
    my $self  = {};
    $self->{"KEY"} = $key;
    $self->{"USEHTTPS"} = $useHTTPS;
    $self->{"VERSION"} = "2.4.0";
	bless ($self, $class);
    return $self;
}

sub makeCall {
	$self = shift;
    $args = shift;
    $args->{"key"} = $self->{"KEY"};

    my $query = http_build_query( $args );

    my $request = HTTP::Request->new;
    $request->method( "POST" );
    $request->header( "Content-type" => "application/x-www-form-urlencoded" );
    $request->header( "User-Agent" => "SurveyTown PERL Wrapper " . $self->{"VERSION"} );
    $request->uri( ( $self->{"USEHTTPS"} ) ? "https://" : "http://" . "api.myfeedback.io/2/REST/" );
    $request->content( $query );

    my $ua = LWP::UserAgent->new;
    my $response = $ua->request( $request );

    my $json = JSON->new->allow_nonref;
    my $out = $json->decode( $response->content );
    
    return $out;
}

1;